#!/usr/bin/perl
############################################################################
#
#   (c) Markus Wolf, 1998
#
############################################################################
#
# wolfgast.cgi
# COPYRIGHT NOTICE                                                           
# Copyright 1998 Markus Wolf     
# All Rights Reserved.                     
# EMail: perl@perl-archiv.de
# URL  : http://www.perl-archiv.de  
#                                                                            
# wolfgast.cgi may be used and modified free of charge by anyone so long as       
# this copyright notice and the comments above remain intact.  By using this 
# code you agree to indemnify Markus Wolf from any liability that           
# might arise from it's use.                                                   
#                                                                            
# Selling the code for this program without prior written consent is         
# expressly forbidden.  In other words, please ask first before you try and  
# make money off of my program.                                              
#                                                                            
# Obtain permission before redistributing this software over the Internet or 
# in any other medium.	In all cases copyright and header must remain intact.
#
# Der Einsatz des Scripts erfolgt auf eigene Gefahr. Fr die richtige
# Funktionsweise bernehme ich keine Garantie.
#
############################################################################
# 
# -Adminmodus zum Lschen von Eintrgen
# -FileLocking
# -keine Reloadmglichkeit
# -Eingabenpfung
# -Design der Eintrge ber Schablone
# -Seitenweise Anzeige (unterschreitet nie den angegebenen Wert, dh auf
#  der letzten Seite erscheinen mind. die in der $anzan angegebenen
#  Eintrge, die Anzahl der vorherigen Seiten wird ber den Modulo
#  berechnet. Es steht also nie nur ein einzelner Eintrag auf einer
#  Seite. Ist gerade fr mein Layout wichtig.
#
# -Mehr fllt mir nun nicht mehr ein. Fr Anregungen bin ich aber 
#  jederzeit offen.
#
###########################################################################
#
# Bitte nicht vergessen mir
# die URL durchzugeben, wo das Script luft.
#
# Einbindung : http://mein.server.de/cgi-bin/wolfgast.cgi?show   ODER
#			   http://mein.server.de/cgi-bin/wolfgast.cgi
#
# Lschenmod : http://mein.server.de/cgi-bin/wolfgast.cgi?admin
#
# Ein Datenfile mu nicht bestehen. Wird mit dem ersten Eintrag
# angelegt.
#
############################################################################
#
# Bei Problemen oder Anpassungen helfe ich gerne, aber zuerst mal die
# FAQ auf meiner Seite anschauen und die Anleitung genau durchlesen.
#
############################################################################


#Ermittlung und Wechsel in das aktuelle Verzeichnis (CGI)
 $base_dir = rindex ($0, "\\") ;
 $base_dir = rindex ($0, "/") if ($base_dir < 0) ;
 $script_dir = substr( $0, 0, $base_dir) ;
 chdir($script_dir) ;


############################################################################
#Variablendefinition
############################################################################

#Ausgabepuffer auschalten, Ausgabe beginnt sofort, nicht erst nach
#Beendigung des Scripts
 $| = 1 ;

#Datenverzeichnis fr CGI (ausgehend vom CGI-Verzeichnis)
 $data_dir = "./data" ;

#Gstebuch-Datenfile
 $dat_file = "$data_dir/gaeste.txt" ;

#Schablone fr das HTML-Design der Eintrge
 $html_templ = "$data_dir/gast.tmpl" ;

#Name und WWW-Adresse des GSTEBUCH-Scriptes
 $cgi_www="wolfgast.cgi" ;

#Name und WWW-Adresse des REDIR-Scriptes
 $red_www="redir.cgi" ;

#Grafikpfad-absolut (URL)
 $pic_dir="../pics" ;

#Schriftart
 $font = "Verdana,Arial,Helv" ;

#Titel des Gstebuches
 $title="Gstebuch" ;

#Anzeige pro Seite (alles auf eine Seite: 100000 :-)) )
 $anzen=5 ;
 $anzan=$anzen ;

#max. Lnge (in Zeichen)fr Gstebucheintrag (0 fr keine Begrenzung)
 $max_length=100 ;

#Restanzeigeberechnung, dh die in $anzen spezifierte Anzahl
#pro Seite wird mind. eingehalten, dh ist von Vorteil, wenn
#man nicht mchte, da zB auf der letzten Seite nur ein Eintrag
#steht. Man allerdings fast keinen Einflu auf die angezeigte
#Menge. ZB werden bei $anzen=20 erst ab dem 40 Eintrag 2 Seiten
#angezeigt. (1=ja / 0=nein)
 $rest_show=1 ;

#File-Locking 0 fr nein (WinXX)/1 fr ja
 $lock=0 ;

#Zeitverschiebung in Stunden (-/+ mglich)
 $zeitverH=0 ;

#Mail an Admin bei neuem Eintrag 
#1=ja / 0=nein
 $adminmail=1 ;

#Fr Mailfunktion 
#0=Mail verschicken per sendmail
#1=Mail in Datenverzeichnis schreiben
 $offline=1 ;

#Mailprogramm (nur Unix)
 $mailprog = "/usr/bin/sendmail" ;

#Mailempfnger
 $webmaster = "perl\@perl-archiv.de" ;

#Pawort fr den Admin(Lsch)modus (unbedingt ndern)
 $pw = "pw" ;
 $pw=`cat /var/run/gastpass`;
 chop($pw); # Letztes Zeichen lschen


############################################################################
#Programmablauf
############################################################################

@para = split(/&/ , $ENV{'QUERY_STRING'}) ;
$para[0]="" if !$para[0] ;
$para[1]=0  if !$para[1] ;


if ($para[0] eq "show" || $para[0] eq "admin") {

	&read_data() ;
	&htmlhead ;
	&show($para[1]) ;
	&htmlfoot ;

} elsif ($para[0] eq "form") {

	&read_data() ;
	&htmlhead ;
	&sign_form() ;

} elsif ($para[0] eq "new") {
	
	&datum_zeit() ;
	&new() ;
	print "Location: $red_www?$cgi_www?show\n\n" ;

} elsif ($para[0] eq "del") {

	&del() ;
	print "Location: $red_www?$cgi_www?show&$FM{'showid'}\n\n" ;

} else {

	&read_data() ;
	&htmlhead ;
	&show('0') ;
	&htmlfoot ;
}



############################################################################
# Unterprogramme
############################################################################

############################################################################
#Datendatei einlesen
#Bei dieser Art der Anzeige arbeite ich nicht sequentiell, dh da das
#ganze Datenfile eingelesen und dann verarbeitet wird. Bei vielen
#virtuellen Servern ist ein CGI-Wrapper installiert, der den Speicher
#pro CGI-Script auf eine bestimmte Gre beschrnkt (zB 500kb), daher
#arbeitet das Gstebuch bei einer Gre von ber zB 500kb nicht mehr.
#Auskunft gibt hierber der Provider.
############################################################################

sub read_data {


my $line , @guest_set ;


open (DAT , "<$dat_file") ;

 while ($line=<DAT>) { 

	push ( @guest_set , $line ) ; 
 }

close(DAT) ;


foreach $line (@guest_set) {

	push ( @guest , [ split(/\|/ , $line) ] ) ;
}


@guest=reverse @guest ;			#Umkehrung der Reihenfolge
$guests = $#guest ;				#Anzahl der Eintrge


&rest_show if ($rest_show==1) ;	#Berechnung der Anzeigeanzahl


}


############################################################################
#Ausgabe der Eintrge
#Hier wird die Anzeige der einzelnen Eintrge gesteuert. Das Aussehen eines
#Eintrages wird ber die beiliegende Schablone gesteuert.
############################################################################

sub show {


my $anzeige_von=$_[0] ;
my $x=0 ;
my @html ;
my $html="" ;
my $html_tmp="" ;


open (HTML , "<$html_templ") ;
@html=<HTML> ;
close(HTML) ;

$html = join(/ / , @html) ;


#Admin-Modus
print "<form method=\"post\" action=\"$cgi_www?del\">" if ($para[0] eq "admin") ;


#Ausgabe der Eintrge: 
#Hier kann das Design der einzelnen Eintrge gendert werden

for $x ($anzeige_von .. $anzeige_von+$anzan-1) {

		$html_tmp=$html ;
		last if($x == $guests) ;
   
		if($guest[$x][4] =~ /http:\/\/.*\./) { 
			$hp="<a href=\"$guest[$x][4]\" target=\"new\">$guest[$x][4]</a>"; 
		} else { 
			$hp="keine Homepage"; 
		} 
		
		if($guest[$x][2] =~ /.*\@.*\..*/) { 
			$em="<a href=\"mailto:$guest[$x][2]\">$guest[$x][2]</a>"; 
		} else { 
			$em="keine E-Mail"; 
		} 

		if ($para[0] eq "admin") {
			$html_tmp =~ s/<!--admin-->/<input type=radio name=\"del\" value=\"$guest[$x][0]\">&#160;/ig ;
		} 

		$html_tmp =~ s/<!--name-->/$guest[$x][1]/ig ;
		$html_tmp =~ s/<!--text-->/$guest[$x][3]/ig ;
		$html_tmp =~ s/<!--mail-->/$em/ig ;
		$html_tmp =~ s/<!--www-->/$hp/ig ;
		$html_tmp =~ s/<!--font-->/$font/ig ;	
		$html_tmp =~ s/<!--time-->/$guest[$x][5]/ig ;
		$html_tmp =~ s/<!--pics-->/$pic_dir/ig ;	

		print $html_tmp ;
}


#Admin-Modus
print "<center><font face=\"$font\" size=-1>Pawort:&nbsp;<input type=text name=pw size=10>&#160;&#160;&#160;&#160;<input type=hidden value=\"$anzeige_von\" name=showid><input type=submit value=\"Markierten Eintrag lschen\"></form></center><br>" if ($para[0] eq "admin") ;


}


############################################################################
#Neuer Eintrag
#Hier wird der neue Einrag aus dem Formular ausgelesen und auf 
#Sonderzeichen gecheckt. Es wird nur eine Leerzeile erlaubt, die anderen
#werden rausgeworfen. HTML-Tags werden als solche (nachher
#sichtbar) geschrieben. Geprft wird auf die Felder NAME und 
#KOMMENTAR.
############################################################################

sub new {


my $guest="" ; 
my $buffer="" ;
my @paare="" ;
my $paar="" ;
my $val1="" ; 
my $val2="" ; 
my $key="" ;


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@paare = split(/&/, $buffer);

foreach $paar (@paare){

		($val1, $val2) = split(/=/, $paar);

		$val1 =~ tr/+/ /;
		$val1 =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$val2 =~ tr/+/ /;
		$val2 =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$val2 =~ s/<([^>]|\n)*>/ /g;

		$FM{$val1} = $val2;
}


if ((!$FM{'name'} || !$FM{'com'}) || ($FM{'com'} && length($max_length)>$max_length && $max_length > 0 )) {

	&er_form() ;

} else {
	
	foreach $key (keys %FM) {

		$FM{$key} =~ s/\&/\&amp\;/g;
		$FM{$key} =~ s/"/\&quot\;/g;
		
		$FM{$key} =~ s/\cM\n/<BR>/g;
		$FM{$key} =~ s/\n\cM/<BR>/g;
		$FM{$key} =~ s/\cM/<BR>/g;
		$FM{$key} =~ s/\n/<BR>/g;
		$FM{$key} =~ s/\s+/ /g;
		
		$FM{$key} =~ s/\s+/ /g;
		$FM{$key} =~ s/^\s+//g;
		$FM{$key} =~ s/\s+$//g;
	}


	$guest = "$datsort\|$FM{'name'}\|$FM{'email'}\|$FM{'com'}\|$FM{'url'}\|$ndate\|" ;

	open (DATNEW , ">>$dat_file") ;
	&LockFile(DATNEW);
	print DATNEW "$guest\n" ;
	&UnlockFile(DATNEW);
	close (DATNEW) ;

 	&send_mail() if $adminmail==1 ; 
}


}


############################################################################
#Fehlerausgabe bei nicht ausgefllten Feldern des Formulars
#Sollten nicht alle notwendigen Felder (Name, Kommentar) ausgefllt 
#werden, wird das Formular geladen und mit einer Fehlermarkierung an
#den fehlenden Feldern wieder ausgegeben. WICHTIG - die Kommentare
#innerhalb des HTML-Formulars mssen fr diese Funktion drinbleiben
############################################################################

sub er_form {


#Hier kann man die Markierung der fehlenden Felder angeben, kann auch eine Grafik sein
my $errmark="&nbsp;<font face=\"$font\" color=ff0000 size=-1><b>X<\/b><\/font>&nbsp;" ;
$x_hinweis = "Ihr mt mindestens die mit einem $errmark markierten Felder ausfllen." ;


$x_name = $errmark if (!$FM{'name'}) ;
$x_text = $errmark if (!$FM{'com'}) ;
$x_laenge = "<font face=\"$font\" color=ff0000 size=-2>Maximal zulssige Lnge von $max_length Zeichen berschritten!</font><br>&nbsp;<br>" if (length($FM{'com'}) > $max_length && $max_length>0) ;


&read_data() ;
&htmlhead ;
&sign_form() ;


exit ;


}


############################################################################
#Lschen eines Eintrages im Adminmodus
#ber den Admin-Aufruf mit dem Parameter ADMIN, knnen einzelne 
#Eintrge gelscht werden. -> dies ist die Lschfunktion
############################################################################

sub del {


my $buffer="" ; 
my @paare="" ; 
my $paar ;
my $val1 ; 
my $val2 ;
my $x=0;


read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@paare = split(/&/, $buffer);

foreach $paar (@paare){

		($val1, $val2) = split(/=/, $paar);

		$val1 =~ tr/+/ /;
		$val1 =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		$val2 =~ tr/+/ /;
		$val2 =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

		$FM{$val1} = $val2;
}


if ($FM{'pw'} eq $pw && $FM{'del'}) {

	&read_data() ;

	open (DAT , ">$dat_file") ;
	&LockFile(DAT);

	for $x (0...$guests) {
		if ($FM{'del'} ne $guest[$x][0]) {
			print DAT "$guest[$x][0]|$guest[$x][1]|$guest[$x][2]|$guest[$x][3]|$guest[$x][4]|$guest[$x][5]|\n" ;
		}
	}

	&UnlockFile(DAT);
	close(DAT) ;
}


#Fr den Fall, dass das Script einfach mit DEL aufgerufen wird
$FM{'showid'}="0" if !$FM{'showid'} ;


}


############################################################################
#Ausgabe des HTML-Kopfes
#incl. der Drop-Liste fr die schnelle Erreichung der Eintragsseiten.
############################################################################

sub htmlhead {


my $ix=0  ;
my $ix2=0 ;
my $ix3=0 ;


print "Content-Type: text/html\n\n" ;

print <<"EOM";

<HTML>
<HEAD>

<TITLE>$title</TITLE>

<style type="text/css">
<!--
   A:link {text-decoration: none; color: steelblue}
   A:visited {text-decoration: none; color: steelblue}
   A:hover {color: steelblue}
-->
</style>

<SCRIPT LANGUAGE="JavaScript">
<!--
function jump (url) {
window.open(url,'_self')
}
//-->
</SCRIPT>

</head>


<body background="$pic_dir/gasthin.gif" bgcolor="#FFFFFF" text="#000000" link="steelblue" vlink="steelblue" alink="steelblue">

<a name="oben">&#160;</a>

<img src="$pic_dir/trenner.gif" border=0 width=55 height=1 align=left>

<table border=0 cellspacing=0 cellpadding=0 width=600>

<tr>
<td>
	<form method="post" action="$red_www">

	<table border=0 cellspacing=0 cellpadding=0 width=100%>
	<tr>
	<td bgcolor="#FFFFFF" valign=top><img src="$pic_dir/trenner.gif" width=20 height=1></td>

	<td valign=top bgcolor="#FFFFFF">

		<table border=0 cellspacing=0 cellpadding=0 width=100%>
		<tr>
		<td valign=top><font face="$font" size=+1><b>$title</b></font></td>
		<td valign=top align=right>

		<select name="links" size=1 OnChange="jump(this.options[this.selectedIndex].value)">
			<option value="$cgi_www?form">eintragen | sign</option>
EOM

			for ($ix=1 ; $ix <= $guests ; $ix+=$anzan) {

				$ix2+=$anzan ;
				$ix3=$ix-1 ;
				$ix2=$guests if ($ix2 > $guests) ;  
				print "<option value=\"$cgi_www?show&$ix3\">$ix - $ix2</option>\n " ;
			}

			print <<"EOM" ;

		</select>	
		</td>
		<td valign=top>&nbsp;<input type=image src="$pic_dir/akt.gif" border=0></td>
		</tr>
		</table>&#160;
</form>
	
EOM


}


############################################################################
#Ausgabe des HTML-Fusses
#incl. seitenweise Anzeige der Eintrge. Die Anzahl pro Seite kann ber
#den Parameter $anzan am Beginn gesteuert werden.
############################################################################

sub htmlfoot {


my $anzeige_zurueck = $para[1]-$anzan ;
my $anzeige_weiter  = $para[1]+$anzan ;
my $anzeige_von     = $para[1]+1 ;
my $anzeige_bis     = $para[1]+$anzan ;


print <<"EOM" ;

	<table border=0 width=100% cellspacing=0 cellpadding=0 width=100%>
	<tr>
        <td>
             <font face="$font" color="#FFFFFF">
EOM


if($anzeige_zurueck >= 0) {

	if ($para[0] eq "admin") {

print <<"EOM" ;
<a href="$cgi_www?admin&$anzeige_zurueck"  onmouseover="window.status='Vorherige $anzan ...';return true;" onmouseout="window.status='';return true;"><img src="$pic_dir/zurueck.gif" border=0 alt="Vorherige $anzan ..."></a>
EOM

	} else {

print <<"EOM" ;
<a href="$cgi_www?show&$anzeige_zurueck"  onmouseover="window.status='Vorherige $anzan ...';return true;" onmouseout="window.status='';return true;"><img src="$pic_dir/zurueck.gif" border=0 alt="Vorherige $anzan ..."></a>
EOM

	}

} else {

print <<"EOM" ;
&#160;
EOM

}


if ($anzeige_weiter>$guests) { $anzeige_bis=$guests ; }


print <<"EOM" ;
 </td>
        <td align=center width=100%>
                <font face="$font" color="#000000" size=-2>
                <b>$anzeige_von-$anzeige_bis \| $guests Eintrge</b>
        </td>
        <td align=right>
EOM


if($anzeige_weiter<$guests) {

	if ($para[0] eq "admin") {

print <<"EOM" ;
<a href="$cgi_www?admin&$anzeige_weiter" onmouseover="window.status='Nchste $anzan ...';return true;" onmouseout="window.status='';return true;"><img src="$pic_dir/weiter.gif" border=0 alt="Nchste $anzan ..."></a>
EOM

	} else {

print <<"EOM" ;
<a href="$cgi_www?show&$anzeige_weiter" onmouseover="window.status='Nchste $anzan ...';return true;" onmouseout="window.status='';return true;"><img src="$pic_dir/weiter.gif" border=0 alt="Nchste $anzan ..."></a>
EOM

	}

} else {

print <<"EOM" ;
&#160;
EOM

}


print <<"EOM" ;

			</td></tr></table>	
		</td>

        <td valign=top bgcolor="#ffffff" align=right>
                        <img src="$pic_dir/trenner.gif" width=20 height=1>
        </td>
		</tr></table>

	</td>
</tr>

<tr>
	<td align=center valign=top><br><br><a href="http://www.perl-archiv.de" target="new"><font face="$font" color="#bebebe" size=-2>&copy Perl/CGI-Archiv</font></a>&nbsp;&nbsp;&nbsp;&nbsp;

</td>

</tr>

</table>

<br>
<br>
&#160;

</body>
</html>

EOM

exit;


}


############################################################################
#Bestimmung des aktuellen Datums und der Uhrzeit fr den Eintrag
#Diese Form der Ermittlung ist Jahr 2000 fhig ($year = 1900+$year).
#ber den Parameter $zeitverH kann eine Zeitverschiebung fr US-Server
#eingegeben werden.
############################################################################

sub datum_zeit {

my $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst ;

$time = time;
	
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time+($zeitverH*3600));
	
$mon = $mon+1;
	
if ($min < 10) { $min = "0$min"; }
if ($hour < 10) { $hour = "0$hour"; }
if ($mon < 10) { $mon = "0$mon"; }
if ($mday < 10) { $mday = "0$mday"; }

$year = 1900+$year;

$ndate1 = "$mday.$mon.$year ";
$ndate = $ndate1."- $hour\:$min";
$datsort = "$year$mon$mday$hour$min$sec" ; 

}


############################################################################
#File-Sperre
#fr gemeinsamen File-Zugriff
#->nur Unix
############################################################################

sub LockFile {

local(*DATEI=@_) ;

if ($lock==1) {
	flock(DATEI,2);
}


}


############################################################################
#File-Sperre aufheben
#schreibender Zugriff zu Ende
#->nur Unix
############################################################################

sub UnlockFile {

local(*DATEI) = @_;

if ($lock==1) {
	flock(DATEI,8);
}


}


############################################################################
#Admin-Mail verschicken
#Auf Wunsch wird dem Admin eine Mail mit dem neuen Gstebucheintrag 
#geschickt. Die Steuerung erfolgt ber einen Parameter an Anfang des 
#Scripts -> $offline und $adminmail
#
#Geht nur mit Unix, fr NT ist diese Form nur bedingt geeignet.
#Es gibt zwar 1:1 Umsetzungen des Unix-Sendmails fr NT, diese
#werden aber nur sehr sehr selten eingestzt, da sie im Vergleich zu
#BLAT etwas kosten.
############################################################################

sub send_mail {


if($offline==1) {

	open(MAIL,">$data_dir/mail.txt")  ;

} else {

	open(MAIL,"|$mailprog -t") ;
}


print MAIL "To: $webmaster\n";
print MAIL "From: $FM{'email'} ($FM{'name'})\n";
print MAIL "Subject: neuer Gaestebuch-Eintrag\n\n";

print MAIL "---------------------------------------------------------------------------\n";
print MAIL "$FM{'name'}\n";
print MAIL "$FM{'email'}\n";
print MAIL "$FM{'url'}\n";
print MAIL "$ndate\n";
print MAIL "---------------------------------------------------------------------------\n";
print MAIL "\n$FM{'com'}\n";
print MAIL "\n---------------------------------------------------------------------------\n";
print MAIL "Der verwendete Browser: $ENV{'HTTP_USER_AGENT'}";
print MAIL "\n---------------------------------------------------------------------------\n";

   
close (MAIL);


}


#############################################################################
#Berechnung der tatschlichen Anzeige pro Seite (rekursive Funktion - hier 
#nur etwas ndern, wenn man genau weis, was das fr Auswirkungen haben
#kann. Unter Umstnden kann man damit den Rechnung abschissen!)
#############################################################################

sub rest_show {

if ( $guests%$anzan < $anzen && $guests >= $anzan) {

	$anzan++ ;
	&rest_show() ;
}


}


#############################################################################
#Ausgabe des Eintragsformulares
#############################################################################

sub sign_form {


$FM{'url'}="http://" unless $FM{'url'} ;
$FM{'com'} =~ s/\n//g ;
$x_hinweis="" if ($FM{'name'} && $FM{'com'}) ;


print <<"EOM" ;

<font face="$font" size=-1>

Hier k&ouml;nnt ihr euch in meinem G&auml;stebuch verewigen. 

</p>

<br>
<br>

<form name="mail" method=POST action="$cgi_www?new">

<table border=0 cellspacing=3>

EOM

if ($x_hinweis) {

print <<"EOM" ;

<tr>
	<td bgcolor="#f9f9f9"><br><font face="$font" size=-1 color="#ff0000">&nbsp;Fehler:</font><br>&nbsp;<br></td>
	<td>&nbsp;</td>
	<td><font face="$font" size=-1>$x_hinweis</font></td>
</tr>

EOM

}

print <<"EOM" ;

<tr>
	<td bgcolor="#f9f9f9"><font face="$font" size=-1>&nbsp;Name:</font></td>
	<td>$x_name</td>
	<td><input type=text name="name" size=44 maxlength=140 value="$FM{'name'}"></td>
</tr>

<tr>
	<td bgcolor="#f9f9f9"><font face="$font" size=-1>&nbsp;E-Mail:</font></td>
	<td>$x_mail</td>
	<td><input type=text name="email" size=44 maxlength=140 value="$FM{'email'}"></td>
</tr>

<tr>
	<td valign=top  bgcolor="#f9f9f9"><font face="$font" size=-1>&nbsp;Text:</font><br><img src="$pic_dir/trenner.gif" border=0 width=120 height=1></td>
	<td valign=top>$x_text</td>
	<td><textarea name="com" rows=10 cols=42 wrap=virtual>$FM{'com'}</textarea><br>$x_laenge</td>
</tr>

<tr>
	<td  bgcolor="#f9f9f9"><font face="$font" size=-1>&nbsp;Homepage:</font></td>
	<td>$x_url</td>
	<td><input type=text name="url" value="$FM{'url'}" size=44 maxlength=140></td>
</tr>

<tr>
	<td bgcolor="#f9f9f9"><img src="/pics/trenner.gif" border=0 width=120 height=1></td>
	<td><!--submit--></td>
	<td><br><br><input type=submit value="Ins Gstebuch eintragen ..."></td>
</tr>

</table>	

</form>
	</td>

        <td valign=top bgcolor="#ffffff" align=right>
                        <img src="$pic_dir/trenner.gif" width=20 height=1>
        </td>
</tr>

</table>


	</td>
</tr>

<tr>
	<td align=center valign=top><br><br><a href="http://www.perl-archiv.de" target="new"><font face="$font" color="#bebebe" size=-2>&copy Perl/CGI-Archiv</font></a>&nbsp;&nbsp;&nbsp;&nbsp;

</td>

</tr>

</table>

<br>
<br>
&#160;

</body>
</html>


EOM


}


#############################################################################